#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int values[120000];
int times[120000];
int sum[120000];
int mins[3600], maxs[3600];
int minl[60], maxl[60];

int min(int a, int b)
{
    if (a < b) return a;
    return b;
}

int max(int a, int b)
{
    if (a > b) return a;
    return b;
}

void build_minmax(int samples)
{
    int i, j, cmin, cmax;
    for (i=0; i<samples/50; i++) {
	cmax = 0; cmin = 1000000;
	for (j=0; j<50; j++) {
	    cmax = max(cmax, values[i*50+j]);
	    cmin = min(cmin, values[i*50+j]);
	}
	mins[i] = cmin; maxs[i] = cmax;
	printf("** mins[%d] = %d\n", i, cmin);
    }
    for (i=0; i<samples/2500; i++) {
	cmax = 0; cmin = 1000000;
	for (j=0; j<50; j++) {
	    cmax = max(cmax, maxs[i*50+j]);
	    cmin = min(cmin, mins[i*50+j]);
	}
	minl[i] = cmin; maxl[i] = cmax;
	printf("** minl[%d] = %d\n", i, cmin);
    }
}

int get_minmax(int start, int end, int getmax)
{
    int cmax = 0, cmin = 1000000, pos = start;
    while(1) {
	if (pos >= end) break;
	if (pos % 2500 == 0 && pos + 2500 < end) {
	    cmax = max(cmax, maxl[pos/2500]);
	    cmin = min(cmin, minl[pos/2500]);
	    pos += 2500;
	}
	if (pos % 50 == 0 && pos + 50 < end) {
	    cmax = max(cmax, maxs[pos/50]);
	    cmin = min(cmin, mins[pos/50]);
	    pos += 50;
	} else {
	    cmax = max(cmax, values[pos]);
	    cmin = min(cmin, values[pos]);
	    pos++;
	}
    }
    //if (!getmax) printf("** min(%d %d) = %d\n", start, end, cmin);
    if (getmax) return cmax;
    return cmin;
}

int main(int argc, char **argv)
{
    int ret, samples, conditions, i, wsize, agval, j, matching;
    char comp[4], aggr[4];
    while (1) {
	ret = scanf("%d\n", &samples);
	if (ret < 1) break;
	for (i=0; i<samples; i++) {
	    scanf("%d %d\n", &times[i], &values[i]);
	}

	sum[0] = 0;
	for (i=1; i<samples; i++) {
	    sum[i] = sum[i-1] + values[i-1];
	}
	build_minmax(samples);

	scanf("%d\n", &conditions);
	for (i=0; i<conditions; i++) {
	    scanf("%s %s %d\n", comp, aggr, &wsize);
	    int wstart = 0;
	    matching = 0;
	    for (j=1; j<samples; j++) {
		int samp = values[j];
		while (times[wstart] < times[j] - wsize) wstart++;
		//printf("** window for sample %d %d starts at %d %d\n", j, times[j], wstart, times[wstart]);
		if (aggr[1] == 'v') {
		    agval = sum[j] - sum[wstart];
		    samp *= j-wstart;
		} else if (aggr[1] == 'i') {
		    agval = get_minmax(wstart, j, 0);
		} else if (aggr[1] == 'a') {
		    agval = get_minmax(wstart, j, 1);
		}
		//printf("** aggr value is %d, sample is %d\n", agval, samp);
		if (comp[0] == 'g' && samp > agval) matching++;
		if (comp[0] == 'l' && samp < agval) matching++;
	    }
	    printf("%d\n", matching);
	}
    }
    return 0;
}
